% script_translation.m
% to render a sample of speckle images translated by n*.1 pixel, n between 0 and 1 

clear all, close all;

myparamalgo = paramalgo(500,.1,'single',2^27);

myparamsensor = paramsensor(8,.9,[512,512]);

myparamspeckle = paramspeckle('E',0.5,150000,0.8);

s = rng ; % seed for the random generator

% rendering of a non-deformed speckle

rng(s)  
tic
SpeckleImage00 = SpeckleRenderGPU(myparamalgo,myparamsensor,myparamspeckle,@identity);
t=toc;
disp(['Computation time: ',num2str(t/60),' min.'])
SpeckleImage00_q = quantization(SpeckleImage00, myparamsensor.nbit);
imwrite(SpeckleImage00_q,'speckle00b.png')
pause(30) 

rng(s) 
tic
SpeckleImage01 = SpeckleRenderGPU(myparamalgo,myparamsensor,myparamspeckle,@translation01);
t=toc;
disp(['Computation time: ',num2str(t/60),' min.'])
SpeckleImage01_q = quantization(SpeckleImage01, myparamsensor.nbit);
imwrite(SpeckleImage01_q,'speckle01b.png')
pause(30) 

rng(s) 
tic
SpeckleImage02 = SpeckleRenderGPU(myparamalgo,myparamsensor,myparamspeckle,@translation02);
t=toc;
disp(['Computation time: ',num2str(t/60),' min.'])
SpeckleImage02_q = quantization(SpeckleImage02, myparamsensor.nbit);
imwrite(SpeckleImage02_q,'speckle02b.png')
pause(30) 

rng(s) 
tic
SpeckleImage03 = SpeckleRenderGPU(myparamalgo,myparamsensor,myparamspeckle,@translation03);
t=toc;
disp(['Computation time: ',num2str(t/60),' min.'])
SpeckleImage03_q = quantization(SpeckleImage03, myparamsensor.nbit);
imwrite(SpeckleImage03_q,'speckle03b.png')
pause(30) 

rng(s) 
tic
SpeckleImage04 = SpeckleRenderGPU(myparamalgo,myparamsensor,myparamspeckle,@translation04);
t=toc;
disp(['Computation time: ',num2str(t/60),' min.'])
SpeckleImage04_q = quantization(SpeckleImage04, myparamsensor.nbit);
imwrite(SpeckleImage04_q,'speckle04b.png')
pause(30) 

rng(s) 
tic
SpeckleImage05 = SpeckleRenderGPU(myparamalgo,myparamsensor,myparamspeckle,@translation05);
t=toc;
disp(['Computation time: ',num2str(t/60),' min.'])
SpeckleImage05_q = quantization(SpeckleImage05, myparamsensor.nbit);
imwrite(SpeckleImage05_q,'speckle05b.png')
pause(30) 

rng(s) 
tic
SpeckleImage06 = SpeckleRenderGPU(myparamalgo,myparamsensor,myparamspeckle,@translation06);
t=toc;
disp(['Computation time: ',num2str(t/60),' min.'])
SpeckleImage06_q = quantization(SpeckleImage06, myparamsensor.nbit);
imwrite(SpeckleImage06_q,'speckle06b.png')
pause(30) 

rng(s) 
tic
SpeckleImage07 = SpeckleRenderGPU(myparamalgo,myparamsensor,myparamspeckle,@translation07);
t=toc;
disp(['Computation time: ',num2str(t/60),' min.'])
SpeckleImage07_q = quantization(SpeckleImage07, myparamsensor.nbit);
imwrite(SpeckleImage07_q,'speckle07b.png')
pause(30) 

rng(s) 
tic
SpeckleImage08 = SpeckleRenderGPU(myparamalgo,myparamsensor,myparamspeckle,@translation08);
t=toc;
disp(['Computation time: ',num2str(t/60),' min.'])
SpeckleImage08_q = quantization(SpeckleImage08, myparamsensor.nbit);
imwrite(SpeckleImage08_q,'speckle08b.png')
pause(30) 

rng(s) 
tic
SpeckleImage09 = SpeckleRenderGPU(myparamalgo,myparamsensor,myparamspeckle,@translation09);
t=toc;
disp(['Computation time: ',num2str(t/60),' min.'])
SpeckleImage09_q = quantization(SpeckleImage09, myparamsensor.nbit);
imwrite(SpeckleImage09_q,'speckle09b.png')
pause(30) 

rng(s) 
tic
SpeckleImage10 = SpeckleRenderGPU(myparamalgo,myparamsensor,myparamspeckle,@translation10);
t=toc;
disp(['Computation time: ',num2str(t/60),' min.'])
SpeckleImage10_q = quantization(SpeckleImage10, myparamsensor.nbit);
imwrite(SpeckleImage10_q,'speckle10b.png')

save('displacement8b.mat')



